
# エミュレータ
EMU       := qemu_run

#コマンドを表示するか (コメントアウトで表示する)
PRINT_CMD := 1


#
# メッセージ
#
MSG_CREATING       := "Creating "
MSG_OK             := "OK!"



#
# 各ディレクトリのパス
#

APPS_DIR     = $(SRC_TOP)/apps
TMP_DIR      = $(SRC_TOP)/tmp
TOOLS_DIR    = $(SRC_TOP)/tools
KERNEL_DIR   = $(SRC_TOP)/kernel
FILES_DIR    = $(SRC_TOP)/files
INCLUDE_DIR  = $(SRC_TOP)/include
BIN_DIR      = $(TOOLS_DIR)
CONF_DIR     = $(TOOLS_DIR)


DELETE_TARGET         = $(TMP_DIR)/*
FS_TMPFILE           := FS_TMPFILE
KERNEL_FILENAME      := kernel.bin
DISK_IMAGE_FILENAME  := main.img
KERNEL_SIZE          := 20480
DISK_IMAGEFILE_SIZE  := 1468000


#
# Commands
#

ifdef PRINT_CMD
  PRINT_CMD := @
endif

MAKE         = $(PRINT_CMD)make
LD           = $(PRINT_CMD)ld
AS           = $(PRINT_CMD)nasm
CC           = $(PRINT_CMD)gcc
STRIP        = $(PRINT_CMD)strip
ECHO         = $(PRINT_CMD)echo
MV           = $(PRINT_CMD)mv
CP           = $(PRINT_CMD)cp
RM           = $(PRINT_CMD)rm
CAT          = $(PRINT_CMD)cat
AR           = $(PRINT_CMD)ar
QEMU         = $(PRINT_CMD)qemu
RANLIB       = $(PRINT_CMD)ranlib
WRITEIPLINFO = $(PRINT_CMD)$(BIN_DIR)/writeIPLInfo.pl
MKRESFS      = $(PRINT_CMD)$(BIN_DIR)/mkresfs.pl
ADDPADDING   = $(PRINT_CMD)$(BIN_DIR)/addpadding.pl
MKTMPDIR     = $(PRINT_CMD)$(BIN_DIR)/mktmpdir.pl $(TMP_DIR)


#
# *FLAGS
#

ASFLAGS         = -s -i ../include/ -f bin
ASM_O_FLAGS     = -s -i ../include/ -f elf

CFLAGS          = -c -std=c99 -O0 -Wall -Wa,--32 -m32 -pipe      \
                   -fno-common -fno-builtin -fno-builtin-function \
                   -fno-stack-protector -mno-red-zone

CPPFLAGS        = -I $(INCLUDE_DIR)
LDFLAGS         = -Map $(TMP_DIR)/kernel.map -N -T $(INCLUDE_DIR)/kernel.ld -nostdinc -nodefaultlibs -e boot3
STRIPFLAGS      = -O binary

QEMUFLAGS       = -m 64 -k ja -boot a -fda $(TMP_DIR)/$(DISK_IMAGE_FILENAME) -hda $(TMP_DIR)/$(DISK_IMAGE_FILENAME) -boot c
ADDPADDINGFLAGS = $(TMP_DIR)/$(DISK_IMAGE_FILENAME) $(DISK_IMAGEFILE_SIZE)
MKRESFSFLAGS    = $(TMP_DIR)/$(FS_TMPFILE) $(FILES_DIR)/*

