/*
*    (functions.h)
*/


//TEST
void asm_elfhd       (void);
void simpleShell     (void);







//descriptor.c
bool   initDescriptors  (void);




//screen.c
bool  initScreen     (void);
void  clearScreen    (void);
void  paint          (unsigned int x, unsigned y, unsigned char color);




//print.c
void  print          (const char *format, ...);
void  printc         (const char c, unsigned char color);
void  printchar      (const char c);




//memory.c
bool   initMemory    (void);
void  *kmalloc       (unsigned int size);
void   kfree         (void *p, taskid tid);




//task.c
bool     initTask     (void);
taskid   allocTask    (void);
void     freeTask     (taskid tid);
bool     startTask    (address eip);
void     switchTask   (void);



//fs.c
bool    initFS        (void);
bool    fileLoad      (void *address, char *filename);
bool    fileExists    (const char *filename);
bool    fileSize      (const char *filename);




//fifo.c
void          initFifo8       (struct FIFO8 *fifo);
void          putFifo8        (struct FIFO8 *fifo, char data);
int           getFifo8        (struct FIFO8 *fifo);
FIFO_STATUS   getFifo8Status  (struct FIFO8 *fifo);




//halt.c
void   halt (void);




//timer.c
bool   initTimer            (void);
void   setTimer             (unsigned int timerID, unsigned int timeout);




//keyboard.c
bool   initKeyboard         (void);
int    fgetc                (taskid taskid);




//mouse.c
bool   initMouse             (void);
void   moveMouseCursor       (void);


//inthd.asm
void  intTimerHandler        (void);
void  intKeyboardHandler     (void);
void  asm_inthd0             (void);
void  asm_inthd1             (void);
void  asm_inthd12            (void);

void  asm_exception0         (void);
void  asm_exception1         (void);
void  asm_exception2         (void);
void  asm_exception3         (void);
void  asm_exception4         (void);
void  asm_exception5         (void);
void  asm_exception6         (void);
void  asm_exception7         (void);
void  asm_exception8         (void);
void  asm_exception9         (void);
void  asm_exception10        (void);
void  asm_exception11        (void);
void  asm_exception12        (void);
void  asm_exception13        (void);
void  asm_exception14        (void);
void  asm_exception15        (void);
void  asm_exception16        (void);
void  asm_exception17        (void);
void  asm_exception18        (void);
void  asm_exception19        (void);




//assembly.asm
void  hlt                    (void);
void  cli                    (void);
void  sti                    (void);
void  clihlt                 (void);
void  stihlt                 (void);
void  lgdt                   (void);
void  lidt                   (void);
void  ltr                    (int selector);
int   in8                    (unsigned short int port);
void  out8                   (unsigned short int port, char data);
void  initPIC                (void);
void  enablePaging           (address addr);
void  enableMemoryCache      (void);
void  disableMemoryCache     (void);
void  apmShutdown            (void);
void  asm_runTask            (TASK_REGISTERS *regs, address pageDirectory);
void  asm_saveTask           (TASK_REGISTERS *regs);

