/*
*    (settings.h)
*/



//メモリ管理
#define  MEMORY_SCAN_PRECISION      0x1000
#define  MEMORY_BLOCK_SIZE          0x1000


//FIFOバッファ
#define  FIFO8_SIZE 512


//タスク
#define  TASKID_START           10
#define  TASKID_END             1000
#define  TASK_MAX               (TASKID_END-TASKID_START)
#define  TASK_DEFAULT_PRIORITY  1
#define  TASK_DEFAULT_EFLAGS    0x200



//タイマ
#define  TIMER_MAX           256
#define  TIMER_TASK          1
#define  TIMER_RESET_COUNT   4000000



//割り込み
#define  PIC_PERMITTED_IRQ   0xfc




//各データのアドレス
#define  BOOTINFO_ADDRESS        0x00007c00
#define  GDTR_ADDRESS            0x00009000
#define  LDTR_ADDRESS            0x00009006
#define  CUI_VRAM_ADDRESS        0x000b8000
#define  BOOT3_ADDRESS           0x00100000
#define  IDT_ADDRESS             0x00300000
#define  GDT_ADDRESS             0x00303000
#define  TSS_ADDRESS             0x0031ff00
#define  PAGE_DIRECTORY_ADDRESS  0x00420000
#define  STACK_ADDRESS           0x005fffff
#define  MEMORY_USERAREA_ADDRESS 0x01000000




//ディスクリプタ関連
#define  GDT_CODE_SELECTOR       1*8
#define  GDT_DATA_SELECTOR       2*8
#define  GDT_TSS_SELECTOR        3*8
#define  GDT_USERCODE_SELECTOR   4*8
#define  GDT_USERDATA_SELECTOR   5*8
#define  IDT_ELFTEST_SELECTOR    0x70
#define  IDT_TIMER_SELECTOR      0x20
#define  IDT_KEYBOARD_SELECTOR   0x21
#define  IDT_MOUSE_SELECTOR      0x2c
#define  GDTYPE_CODE             10
#define  GDTYPE_DATA             2
#define  GDTYPE_TSS              9
#define  IDT_INT_HANDLER         0x8e




//I/Oポートアドレス
#define  IOPORT_PIC_SLAVE_IMR    0xa1
#define  IOPORT_PIC_SLAVE_ICW1   0xa0
#define  IOPORT_PIC_SLAVE_ICW2   0xa1
#define  IOPORT_PIC_SLAVE_ICW3   0xa1
#define  IOPORT_PIC_SLAVE_ICW4   0xa1
#define  IOPORT_PIC_MASTER_IMR   0x21
#define  IOPORT_PIC_MASTER_ICW1  0x20
#define  IOPORT_PIC_MASTER_ICW2  0x21
#define  IOPORT_PIC_MASTER_ICW3  0x21
#define  IOPORT_PIC_MASTER_ICW4  0x21
#define  IOPORT_TIMER1           0x43
#define  IOPORT_TIMER2           0x40
#define  IOPORT_KBC1             0x60
#define  IOPORT_KBC2             0x64




//CUI
#define  TAB_SIZE              4
#define  SCREEN_X_MAX          80
#define  SCREEN_Y_MAX          25
#define  SCREEN_FONT_COLOR     0x07

