;
;	(inthd.asm)
;

%include "asm.inc"

[bits 32]

global asm_inthd0, asm_inthd1, asm_inthd12
extern intTimerHandler,  intKeyboardHandler, intMouseHandler


;TEST
;ELFテスト
global asm_elfhd
extern elftestHd
asm_elfhd:
cli
pushad

mov  al,	0x60
out  0x20,	al

call elftestHd

popad
iretd




;タイマハンドラ
asm_inthd0:
cli
pushad
push ds
push es
push fs
push gs


mov  al,	0x60
out  0x20,	al

call intTimerHandler

pop  ds
pop  es
pop  fs
pop  gs


popad
iretd




;キーボードハンドラ
asm_inthd1:
cli
pushad
push ds
push es

mov ax, 0x10
mov ds, ax
mov es, ax

mov  al,	0x61
out  0x20,	al

call intKeyboardHandler

pop  es
pop  ds
popad
iretd




;マウスハンドラ
asm_inthd12:
cli
pushad
push ds
push es

mov ax, 0x10
mov ds, ax
mov es, ax


mov al, 0x64
out 0xa0, al

mov al, 0x62
out 0x20, al

call intMouseHandler

pop  es
pop  ds
popad
iretd



;例外ハンドラ
%macro make_asm_exception 1
  global asm_exception%1
  extern exception%1

 asm_exception%1:
  cli

  pushad
  push ds
  push es

  mov  ax, GDT_DATA_SELECTOR
  mov  ds, ax
  mov  es, ax
  mov  ss, ax

  call exception%1

  pop es
  pop ds
  popad
  iretd
%endmacro



;例外ハンドラを作成
make_asm_exception 0
make_asm_exception 1
make_asm_exception 2
make_asm_exception 3
make_asm_exception 4
make_asm_exception 5
make_asm_exception 6
make_asm_exception 7
make_asm_exception 8
make_asm_exception 9
make_asm_exception 10
make_asm_exception 11
make_asm_exception 12
make_asm_exception 13
make_asm_exception 14
make_asm_exception 15
make_asm_exception 16
make_asm_exception 17
make_asm_exception 18
make_asm_exception 19

